var lsg = {

    autoscroll: 1,
    autogui: 0,

    tree: null,
    startNode: null,
    guitable: null,

    editor: null,
    editor2: null,
    lastSelectionMarker: null,

    initializedElements: [],

    go: function (anchor) {
        var intronode = document.createElement("div");
        intronode.classList.add('intro');
        anchor.append(intronode);

        this.startNode = document.createElement("div");
        this.startNode.classList.add('startnode');
        anchor.append(this.startNode);


    },

    execute: function () {
        try {
            $('.button').prop("disabled", false);
            var code = editor.getValue();
            eval(code);
        } catch (e) {
            addError("" + e);
        }
    },

    refresh: function (editor, editor2) {
        this.editor = editor;
        this.editor2 = editor;
        this.initializedElements = [];
        try {
            document.querySelector('#error').innerText = "";
            if (this.autogui == 1) {
                document.getElementById('inputoutput').innerText = '';
                this.guitable = document.createElement("table");
                $('#inputoutput').append(this.guitable);
            }

            try {
                this.tree = esprima.parseScript(editor.getValue(), { tokens: true, range: true, loc: true }, function (node) {
                });
                if (!this.hasError(this.tree, false)) {
                    this.startNode.innerText = '';
                } else {
                    //todo
                }
                //console.log(this.tree);

                //create in-/output
                this.createInOutput(this.tree.body);


                //create diagramm
                for (var i = 0; i < this.tree.body.length; i++) {
                    this.handleStatement(this.tree.body[i], this.startNode);
                }

                if (this.autogui == 1) {
                    setEditor2Value(document.getElementById('inputoutput').innerHTML);
                }

            } catch (e) {
                document.querySelector('#error').innerHTML = e.description + "<br>Zeile: " + e.lineNumber + ", Spalte: " + e.column;
                //console.log(e);
            }
        } catch (e) {
            //console.log(e);
        }
    },

    hasError: function (t, error) {
        var error = false;
        error = typeof t == "Error";
        return error;
    },

    cleanUp: function (txt) {
        txt = txt.replace(/[\u00A0-\u9999<>\&]/gim, function (i) {
            return '&#' + i.charCodeAt(0) + ';';
        });

        return txt;
    },

    textSubstring: function (start, end) {
        return this.cleanUp(this.editor.getValue().substring(start, end));
    },

    textSubstringByRange: function (range) {
        return this.textSubstring(range[0], range[1]);
    },

    replaceLF: function (txt) {
        var str = $("<div/>").html(txt).text();
        str = str.replace(/(?:\\r\\n|\\r|\\n)/g, " Zeilenumbruch ");
        str = str.replace(/<br>/g, ' Zeilenumbruch ');
        str = str.replace(/" Zeilenumbruch "/g, ' Zeilenumbruch ');
        str = $('<textarea/>').text(str).html();
        str = str.replace(/ Zeilenumbruch /g, ' <i>Zeilenumbruch</i> ');
        return str;
    },

    clearSelectionMarkers: function () {
        if (this.lastSelectionMarker != null) {
            this.editor.removeSelectionMarker(this.lastSelectionMarker);
        }
    },

    setSubtextvisibility: function (visi) {
        if (visi) {
            $('.subtext').fadeIn(100);
        } else {
            $('.subtext').fadeOut(100);
        }
    },

    markScript: function (loc) {
        //console.log(loc);
        this.clearSelectionMarkers();
        this.editor.updateSelectionMarkers();
        this.editor.getSelection().clearSelection();
        this.lastSelectionMarker = new ace.Range(loc.start.line - 1, loc.start.column, loc.end.line - 1, loc.end.column);
        this.editor.addSelectionMarker(this.lastSelectionMarker);
        this.editor.updateSelectionMarkers();
        this.editor.moveCursorTo(loc.start.line - 1, loc.start.column);
        if (this.autoscroll) {
            this.editor.centerSelection();
        }
    },

    markStruktogramm: function (loc) {
        //console.log(loc);
        $('.highlightblock').removeClass('highlightblock');
        $("[data-start-line]").each(function () {
            if ($(this).attr('data-start-line') >= loc.start.line && $(this).attr('data-start-line') <= loc.end.line
                //&& $(this).attr('data-end-line') >= loc.start.line && $(this).attr('data-start-line') <= loc.end.line
            ) {
                $(this).addClass('highlightblock');
            }
        });
    },

    createInOutput: function (treenode) {
        var founds = [];
        this.findTreeVal(treenode, 'type', 'MemberExpression', founds);
        //console.log(founds);
        for (var i = 0; i < founds.length; i++) {
            if (founds[i].property && founds[i].property.name == "value") {
                if (founds[i].object.name) {
                    this.addOuputField(founds[i].object.name, 'in');
                } else if (founds[i].object.arguments && founds[i].object.arguments.length > 0 && founds[i].object.arguments[0].value) {
                    this.addOuputField(founds[i].object.arguments[0].value, 'in');
                }
            } else if (founds[i].property && founds[i].property.name == "getElementById") {
                if (founds[i].object.name && founds[i].object.name != "document") {
                    this.addOuputField(founds[i].object.name, 'in');
                } else if (founds[i].object.arguments && founds[i].object.arguments.length > 0 && founds[i].object.arguments[0].value) {
                    this.addOuputField(founds[i].object.arguments[0].value, 'in');
                }
            }
        }
    },

    findTreeVal: function (node, key, value, founds) {
        if (Array.isArray(node)) {
            for (var i = 0; i < node.length; i++) {
                this.findTreeVal(node[i], key, value, founds);
            }
        }
        if (typeof node === "object") {
            var active = [node];
            while (active.length) {
                var new_active = [], found = [];
                for (var i = 0; i < active.length; i++) {
                    Object.keys(active[i]).forEach(function (k) {
                        var x = active[i][k];
                        if (k == key && x == value) {
                            founds.push(active[i]);
                        } else if (x && typeof x === "object") {
                            new_active.push(x);
                        }
                    });
                }
                active = new_active;
            }
        }
    },

    getFunctions: function () {
        var code = "";
        var founds = [];
        this.findTreeVal(this.tree, 'type', 'FunctionDeclaration', founds);
        for (var i = 0; i < founds.length; i++) {
            code += this.textSubstringByRange(founds[i].range); + "\n";
        }
        return code;
    },

    handleStatement: function (treenode, parentnode) {
        //console.log(treenode); 
        var node = document.createElement("div");
        node.classList.add('block');
        node.setAttribute('title', treenode.type);
        node.setAttribute('data-start', treenode.range[0]);
        node.setAttribute('data-end', treenode.range[1]);
        node.setAttribute('data-start-line', treenode.loc.start.line);
        node.setAttribute('data-end-line', treenode.loc.end.line);
        node.setAttribute('data-start-col', treenode.loc.start.column);
        node.setAttribute('data-end-col', treenode.loc.end.column);
        node.addEventListener('click', function (evt) {
            lsg.markScript(treenode.loc);
            evt.stopPropagation();
        })
        parentnode.append(node);

        if (treenode.type == "ExpressionStatement") {
            if (treenode.expression.type && treenode.expression.type == "AssignmentExpression") {

                if (treenode.expression && treenode.expression.right && treenode.expression.right.callee && treenode.expression.right.callee.name && treenode.expression.right.callee.name == "prompt") {
                    node.setAttribute('title', treenode.expression.type);
                    node.innerHTML = "Eingabe: " + treenode.expression.left.name + "<div class='subtext'>Eingabe erfolgt über modalen Dialog</div>";
                } else if (treenode.expression && treenode.expression.right && treenode.expression.right.property && treenode.expression.right.property.name && treenode.expression.right.property && treenode.expression.right.property.name == "value") {
                    node.setAttribute('title', treenode.expression.type);
                    node.innerHTML = "Einlesen: " + treenode.expression.left.name;
                    if (treenode.expression.right && treenode.expression.right.object && treenode.expression.right.object.arguments && treenode.expression.right.object.arguments.length > 0 && treenode.expression.right.object.arguments[0].value) {
                        this.addOuputField(treenode.expression.right.object.arguments[0].value, 'in');
                    } else if (treenode.expression.right && treenode.expression.right.object && treenode.expression.right.object.name) {
                        this.addOuputField(treenode.expression.right.object.name, 'in');
                    }
                } else if (treenode.expression && treenode.expression.left && treenode.expression.left.type && treenode.expression.left.type == "MemberExpression" && treenode.expression.left.property && treenode.expression.left.property.name && treenode.expression.left.property.name == "value") {
                    if (treenode.expression.left.object && treenode.expression.left.object.arguments && treenode.expression.left.object.arguments.length > 0 && treenode.expression.left.object.arguments[0].value) {
                        this.addOuputField(treenode.expression.left.object.arguments[0].value, 'out');
                        node.innerHTML = "Ausgabe: " + treenode.expression.left.object.arguments[0].value;
                    }
                    if (treenode.expression.left.object.name && treenode.expression.right.range) {
                        this.addOuputField(treenode.expression.left.object.name, 'out');
                        node.innerHTML = "Ausgabe: " + this.textSubstringByRange(treenode.expression.right.range) + "<div class='subtext'>Ausgabe erfolgt in das Feld <i>" + treenode.expression.left.object.name + "</i></div>";
                    }
                } else if (treenode.expression && treenode.expression.left && treenode.expression.left.type && treenode.expression.left.type == "MemberExpression" && treenode.expression.left.property && treenode.expression.left.property.name && (treenode.expression.left.property.name == "innerText" || treenode.expression.left.property.name == "innerHTML")) {
                    if (treenode.expression.left.object && treenode.expression.left.object.arguments && treenode.expression.left.object.arguments.length > 0 && treenode.expression.left.object.arguments[0].value) {
                        this.addStaticOuputField(treenode.expression.left.object.arguments[0].value);
                        node.innerHTML = "Ausgabe: " + treenode.expression.left.object.arguments[0].value + "<div class='subtext'>Ausgabe erfolgt in das Feld <i>" + treenode.expression.left.object.arguments[0].value + "</i></div>";
                    }
                    if (treenode.expression.left.object.name) {
                        this.addStaticOuputField(treenode.expression.left.object.name);
                        node.innerHTML = "Ausgabe: " + this.textSubstringByRange(treenode.expression.right.range) + "<div class='subtext'>Ausgabe erfolgt in das Feld <i>" + treenode.expression.left.object.name + "</i></div>";
                    }
                } else if (treenode.expression && treenode.expression.left && treenode.expression.left.type && treenode.expression.left.type == "MemberExpression" && treenode.expression.left.property && treenode.expression.left.property.name && treenode.expression.left.property.name == "onclick" && treenode.expression.left.object.name) {
                    if (treenode.expression.right.name) {
                        this.addStaticButton(treenode.expression.left.object.name, treenode.expression.right.name);
                        node.innerHTML = this.textSubstringByRange(treenode.expression.range) + "<div class='subtext'>Schalftfläche <i>" + treenode.expression.left.object.name + "</i> mit Funktion <i>" + treenode.expression.right.name + "</i> verbinden</div>";
                    } else if (treenode.expression.right.callee && treenode.expression.right.callee.name) {
                        this.addStaticButton(treenode.expression.left.object.name, treenode.expression.right.callee.name);
                        node.innerHTML = this.textSubstringByRange(treenode.expression.range) + "<div class='subtext'>Schalftfläche <i>" + treenode.expression.left.object.name + "</i> mit Funktion <i>" + treenode.expression.right.callee.name + "</i> verbinden</div>";
                    } else if (treenode.expression.right.body && treenode.expression.right.body.body["0"] && treenode.expression.right.body.body["0"].expression && treenode.expression.right.body.body["0"].expression.callee && treenode.expression.right.body.body["0"].expression.callee.name) {
                        this.addStaticButton(treenode.expression.left.object.name, treenode.expression.right.body.body["0"].expression.callee.name);
                        node.innerHTML = this.textSubstringByRange(treenode.expression.range) + "<div class='subtext'>Schalftfläche <i>" + treenode.expression.left.object.name + "</i> mit Funktion <i>" + treenode.expression.right.body.body["0"].expression.callee.name + "</i> verbinden</div>";
                    }
                } else {
                    node.setAttribute('title', treenode.expression.type);
                    if (treenode.expression.left.name && this.initializedElements.indexOf(treenode.expression.left.name) < 0) {
                        this.initializedElements.push(treenode.expression.left.name);
                        node.innerHTML = "Initialisierung: " + this.textSubstringByRange(treenode.expression.range);
                    } else {
                        node.innerHTML = "Zuweisung: " + this.textSubstringByRange(treenode.expression.range);
                    }
                }
            } else if (treenode.expression.type && treenode.expression.type == "CallExpression") {
                if (treenode.expression.callee && treenode.expression.callee.property && treenode.expression.callee.property.name && treenode.expression.callee.property.name == "log") {
                    node.innerHTML = "Ausgabe: " + this.replaceLF(this.textSubstringByRange(treenode.expression.arguments[0].range));
                    node.innerHTML += "<div class='subtext'>Ausgabe erfolgt in die Konsole</div>";
                } else if ((treenode.expression.callee && treenode.expression.callee.name && treenode.expression.callee.name == "alert")
                    || (treenode.expression.callee && treenode.expression.callee.property && treenode.expression.callee.property.name && (treenode.expression.callee.property.name == "alert" || (treenode.expression.callee.object && treenode.expression.callee.object.name == "document" && (treenode.expression.callee.property.name == "write" || treenode.expression.callee.property.name == "writeln"))))
                ) {
                    node.innerHTML = "Ausgabe: " + this.replaceLF(this.textSubstringByRange(treenode.expression.arguments[0].range));
                    if (treenode.expression.callee.name == "alert" || treenode.expression.callee.property.name == "alert") {
                        node.innerHTML += "<div class='subtext'>Ausgabe erfolgt über modalen Dialog</div>";
                    } else if (treenode.expression.callee.property.name == "write" || treenode.expression.callee.property.name == "writeln") {
                        node.innerHTML += "<div class='subtext'>Ausgabe erfolgt in die Konsole</div>";
                    }
                } else {
                    var html = "Aufruf: " + treenode.expression.callee.name;
                    if (treenode.expression.arguments && treenode.expression.arguments.length > 0) {
                        html += "(";
                        for (var p = 0; p < treenode.expression.arguments.length; p++) {
                            if (treenode.expression.arguments[p].type == "Literal") {
                                html += treenode.expression.arguments[p].value + ", ";
                            }
                            if (treenode.expression.arguments[p].type == "Identifier") {
                                html += treenode.expression.arguments[p].name + ", ";
                            }
                        }
                        html = html.substring(0, html.length - 2);
                        html += ")";
                    }
                    html += "<div class='subtext'>Aufruf der Funktion <i>" + treenode.expression.callee.name + "</i></div>"
                    node.classList.add('call');
                    node.innerHTML = html;
                }
            } else if (treenode.expression.type && treenode.expression.type == "UpdateExpression") {
                node.innerHTML = "Zuweisung: " + this.textSubstringByRange(treenode.expression.range);
            } else {
                node.innerHTML = "?: " + treenode.expression.name;
            }
        }

        if (treenode.type == "VariableDeclaration") {
            var identifiers = "";
            var inclInit = false;
            var readValue = false;
            var inputMode = "Einlesen";
            for (var i = 0; i < treenode.declarations.length; i++) {
                identifiers += treenode.declarations[i].id.name;
                if (treenode.declarations[i].init != null) {
                    inclInit = true;
                    var subtext = "";
                    if (treenode.declarations[i].id.name && this.initializedElements.indexOf(treenode.declarations[i].id.name) < 0) {
                        this.initializedElements.push(treenode.declarations[i].id.name);
                        //console.log(this.initializedElements);
                    }
                    if (treenode.declarations[i].init.callee && treenode.declarations[i].init.callee.name && treenode.declarations[i].init.callee.name == "prompt") {
                        readValue = true;
                        inputMode = "Eingabe";
                        subtext = "<div class='subtext'>Eingabe erfolgt über modalen Dialog</div>";
                    }
                    if (treenode.declarations[i].init.property && treenode.declarations[i].init.property.name && treenode.declarations[i].init.property.name == "value") {
                        readValue = true;
                        if (treenode.declarations[i].init.object && treenode.declarations[i].init.object.arguments && treenode.declarations[i].init.object.arguments.length > 0 && treenode.declarations[i].init.object.arguments[0].value) {
                            this.addOuputField(treenode.declarations[i].init.object.arguments[0].value, 'in');
                            subtext = "<div class='subtext'>Eingabe erfolgt über das Feld <i>" + treenode.declarations[i].init.object.arguments[0].value + "</i></div>";
                        } else if (treenode.declarations[i].init.object && treenode.declarations[i].init.object.name) {
                            this.addOuputField(treenode.declarations[i].init.object.name, 'in');
                            subtext = "<div class='subtext'>Eingabe erfolgt über das Feld <i>" + treenode.declarations[i].init.object.name + "</i></div>";
                        }
                    }

                    // --> dirty
                    inittext = this.textSubstringByRange(treenode.declarations[i].init.range);
                    if (inittext.indexOf('.value') >= 0) {
                        subtext = "<div class='subtext'>Eingabe erfolgt über ein Eingabefeld</div>";
                    }
                    if (inittext.indexOf('prompt') >= 0 || inittext.indexOf('.value') >= 0) {
                        readValue = true;
                        inputMode = "Eingabe";
                    }
                    // <--

                    if (!readValue && treenode.declarations[i].init.range != null) {
                        identifiers += "=" + this.textSubstring(treenode.declarations[i].init.range[0], treenode.declarations[i].init.range[1]);
                    }

                }
                identifiers += ", ";
            }
            if (identifiers.length >= 1) {
                identifiers = identifiers.substring(0, identifiers.length - 2);
            }
            if (subtext == null) {
                subtext = "";
            }

            if (readValue) {
                node.innerHTML = "Deklaration" + (inclInit ? " und " + inputMode : "") + ": " + identifiers + subtext;
            } else {
                node.innerHTML = "Deklaration" + (inclInit ? " und Initialisierung" : "") + ": " + identifiers + subtext;
            }
        }

        if (treenode.type == "ReturnStatement") {
            var html = "Rückgabe: ";
            if (treenode.argument.value) {
                html += treenode.argument.value;
            } else if (treenode.argument.name) {
                html += treenode.argument.name;
            } else if (treenode.argument.callee) {
                html += "Aufruf: " + treenode.argument.callee.name;
            } else {
                html += this.textSubstring(treenode.argument.range);
            }
            node.innerHTML = html;
        }


        if (treenode.type == "BreakStatement") {
            var html = "break";
            html += "<div class='subtext'>Abbruch der aktuellen Schleife</div>";
            node.innerHTML = html;
        }


        if (treenode.type == "IfStatement") {
            var nodeTable = document.createElement("table");
            nodeTable.classList.add("condition");

            var nodeTr00 = document.createElement("tr");
            var nodeTd0 = document.createElement("td");
            nodeTd0.classList.add('conditionTest');
            nodeTd0.setAttribute('colspan', '2');
            nodeTd0.innerHTML = "Ist " + this.textSubstringByRange(treenode.test.range) + " ?";
            nodeTr00.append(nodeTd0);
            nodeTable.append(nodeTr00);

            var nodeTr0 = document.createElement("tr");
            var nodeTd1 = document.createElement("td");
            nodeTd1.classList.add('true');
            nodeTd1.addEventListener('click', function (evt) {
                lsg.markScript(treenode.consequent.loc);
                evt.stopPropagation();
            });
            nodeTd1.innerHTML = "<i>j</i>";
            var nodeTd2 = document.createElement("td");
            nodeTd2.classList.add('false');
            if (treenode.alternate) {
                nodeTd2.addEventListener('click', function (evt) {
                    lsg.markScript(treenode.alternate.loc);
                    evt.stopPropagation();
                });
            }

            nodeTd2.innerHTML = "<i>n</i>";
            nodeTr0.append(nodeTd1);
            nodeTr0.append(nodeTd2);
            nodeTable.append(nodeTr0);

            var nodeTr = document.createElement("tr");
            var node1 = document.createElement("td");
            node1.classList.add('conditionIf');
            nodeTr.append(node1);
            var node2 = document.createElement("td");
            node2.classList.add('conditionElse');
            nodeTr.append(node2);
            nodeTable.append(nodeTr);

            node.append(nodeTable);

            if (treenode.consequent.body) {
                for (var i = 0; i < treenode.consequent.body.length; i++) {
                    this.handleStatement(treenode.consequent.body[i], node1);
                }
            } else {
                this.handleStatement(treenode.consequent, node1);
            }
            if (treenode.alternate) {
                if (treenode.alternate.body) {
                    for (var i = 0; i < treenode.alternate.body.length; i++) {
                        this.handleStatement(treenode.alternate.body[i], node2);
                    }
                } else {
                    this.handleStatement(treenode.alternate, node2);
                }
            }

        }



        if (treenode.type == "WhileStatement") {
            node.innerHTML = "Wiederhole solange " + this.textSubstringByRange(treenode.test.range);
            node.classList.add('loopHead');

            var nodeWhile = document.createElement("div");
            nodeWhile.classList.add('loopBody');
            node.append(nodeWhile);

            if (treenode.body.type == "BlockStatement") {
                for (var i = 0; i < treenode.body.body.length; i++) {
                    this.handleStatement(treenode.body.body[i], nodeWhile);
                }
            } else {
                this.handleStatement(treenode.body, nodeWhile);
            }
        }



        if (treenode.type == "DoWhileStatement") {
            node.classList.add('loopFoot');

            var nodeWhile = document.createElement("div");
            nodeWhile.classList.add('loopBody');
            node.append(nodeWhile);

            var footerNode = document.createElement("div");
            footerNode.innerHTML = "Wiederhole solange " + this.textSubstringByRange(treenode.test.range);
            node.append(footerNode);

            if (treenode.body.type == "BlockStatement") {
                for (var i = 0; i < treenode.body.body.length; i++) {
                    this.handleStatement(treenode.body.body[i], nodeWhile);
                }
            } else {
                this.handleStatement(treenode.body, nodeWhile);
            }
        }



        if (treenode.type == "ForStatement") {
            var html = '';
            if (treenode.init.type == "VariableDeclaration") {
                html = "Wiederhole von " + this.textSubstringByRange(treenode.init.declarations[0].range);
            }
            if (treenode.init.type == "AssignmentExpression") {
                html = "Wiederhole von " + this.textSubstringByRange(treenode.init.range);
            }
            html += " solange " + this.textSubstringByRange(treenode.test.range) + ", Schrittweite ";
            if (treenode.update.type == "AssignmentExpression") {
                html += treenode.update.right.operator + this.textSubstringByRange(treenode.update.right.right.range);
            }
            if (treenode.update.type == "UpdateExpression") {
                html += this.textSubstringByRange(treenode.update.range);
            }
            node.innerHTML = html;
            node.classList.add('loopHead');

            var nodeFor = document.createElement("div");
            nodeFor.classList.add('loopBody');
            node.append(nodeFor);

            if (treenode.body.type == "BlockStatement") {
                for (var i = 0; i < treenode.body.body.length; i++) {
                    this.handleStatement(treenode.body.body[i], nodeFor);
                }
            } else {
                this.handleStatement(treenode.body, nodeFor);
            }
        }



        if (treenode.type == "FunctionDeclaration") {

            node.style.borderTop = "none";

            var nodeCall = document.createElement("div");
            var node2 = document.createElement("div");
            node2.classList.add('function');
            nodeCall.append(node2);
            var html = "Funktion: <b>" + treenode.id.name + "</b>";// this.textSubstringByRange(treenode.range);
            if (treenode.params && treenode.params.length > 0) {
                html += "(";
                for (var p = 0; p < treenode.params.length; p++) {
                    html += this.textSubstringByRange(treenode.params[p].range) + ", ";
                }
                html = html.substring(0, html.length - 2);
                html += ")";
            }
            node2.innerHTML = html;
            node.append(nodeCall);

            if (treenode.body.type == "BlockStatement") {
                for (var i = 0; i < treenode.body.body.length; i++) {
                    this.handleStatement(treenode.body.body[i], node2);
                }
            } else {
                this.handleStatement(treenode.body, node2);
            }
        }

    },


    addOuputField: function (name, type) {
        try {
            if (!document.querySelector('tr[name=' + name + "]")) {
                var tr = document.createElement("tr");
                tr.setAttribute('name', name);

                var td1 = document.createElement("td");
                td1.innerText = name + ": ";

                var td2 = document.createElement("td");
                var field = document.createElement("input");
                field.setAttribute('id', name);
                field.setAttribute('type', 'text');
                field.setAttribute('title', 'Zugriff: ' + name + ".value");
                field.classList.add(type);
                td2.append(field);

                var td3 = document.createElement("td");
                var t = '';
                if (field.classList.contains('in')) {
                    t = 'in ';
                }
                if (field.classList.contains('out')) {
                    t = 'out ';
                }
                td3.innerText = t;

                tr.appendChild(td1);
                tr.appendChild(td2);
                tr.appendChild(td3);

                this.guitable.append(tr);
            } else {
                var element = document.querySelector('tr[name=' + name + "] input")
                element.classList.add(type);
            }

            var t = '';
            var element = document.querySelector('tr[name=' + name + "] input");
            if (element.classList.contains('in')) {
                t = 'in ';
            }
            if (element.classList.contains('out')) {
                t += 'out ';
            }
            document.querySelector('tr[name=' + name + "] td:nth-child(3)").innerText = t;

        } catch (e) {
            //nop
        }

    },


    addStaticOuputField: function (name) {
        try {
            if (!document.querySelector('tr[name=' + name + "]")) {
                var tr = document.createElement("tr");
                tr.setAttribute('name', name);

                var td1 = document.createElement("td");
                td1.innerText = name + ": ";

                var td2 = document.createElement("td");
                var field = document.createElement("p");
                field.setAttribute('id', name);
                field.setAttribute('title', 'Zugriff: ' + name + ".value");
                field.style.resize = "both";
                field.classList.add('staticout');
                td2.append(field);

                var td3 = document.createElement("td");
                var t = '';
                td3.innerText = '';
                //td3.innerText = 'out';

                tr.appendChild(td1);
                tr.appendChild(td2);
                tr.appendChild(td3);

                this.guitable.append(tr);
            } else {
                var element = document.querySelector('tr[name=' + name + "] input")
                element.classList.add(type);
            }

        } catch (e) {
            //nop
        }

    },

    addFieldNames: function (str) {
        var tokens = str.split(/[\s.()]+/);
        for (var i = 0; i < tokens.length; i++) {
            if (tokens[i] == 'value') {
                this.addOuputField(tokens[i - 1], 'in');
            }
        }
    },

    addStaticButton: function (name) {
        try {
            if (!document.querySelector('tr[name=' + name + "]")) {
                var tr = document.createElement("tr");
                tr.setAttribute('name', name);

                var td1 = document.createElement("td");
                td1.setAttribute('colspan', '3');
                td1.setAttribute('style', 'text-align: center;');

                var btn = document.createElement("input");
                btn.setAttribute('disabled', 'true');
                btn.setAttribute('class', 'button');
                btn.setAttribute('type', 'button');
                btn.setAttribute('value', name);
                btn.setAttribute('id', name);

                td1.append(btn);

                tr.appendChild(td1);

                this.guitable.append(tr);
            } else {
                var element = document.querySelector('tr[name=' + name + "] input")
                element.classList.add(type);
            }

        } catch (e) {
            //nop
        }
    }

}